'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var _accordionItemJsx = require('./accordionItem.js');

var _accordionItemJsx2 = _interopRequireDefault(_accordionItemJsx);

var Accordion = (function (_React$Component) {
    _inherits(Accordion, _React$Component);

    function Accordion(props) {
        _classCallCheck(this, Accordion);

        _get(Object.getPrototypeOf(Accordion.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.state = {
            activeKey: this.props.defaultActiveKey
        };
        this.handleSelect = this.handleSelect.bind(this);
    }

    _createClass(Accordion, [{
        key: 'handleSelect',
        value: function handleSelect(e, key) {
            e.preventDefault();

            if (this.state.activeKey === key) {
                key = null;
            }

            this.setState({
                activeKey: key
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var classSet = this.getClassSet();

            classSet[this.prefixClass(this.props.theme)] = true;

            return _react2['default'].createElement(
                'section',
                _extends({}, this.props, {
                    'data-widget': this.props.classPrefix,
                    className: (0, _classnames2['default'])(classSet, this.props.className) }),
                this.props.data.map(function (item, index) {
                    return _react2['default'].createElement(
                        _accordionItemJsx2['default'],
                        {
                            title: item.title,
                            expanded: item.active && item.disabled,
                            defaultExpanded: item.active && !item.disabled,
                            eventKey: index,
                            key: index },
                        item.content
                    );
                })
            );
        }
    }]);

    return Accordion;
})(_react2['default'].Component);

Accordion.displayName = "Accordion";

Accordion.propTypes = {
    theme: _react2['default'].PropTypes.oneOf(['default', 'basic', 'gapped']),
    data: _react2['default'].PropTypes.array,
    activeKey: _react2['default'].PropTypes.any,
    defaultActiveKey: _react2['default'].PropTypes.any
};

Accordion.defaultProps = {
    classPrefix: 'accordion',
    theme: 'default'
};

module.exports = Accordion;