'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var _mixinsCollapseMixin = require('./mixins/CollapseMixin');

var _mixinsCollapseMixin2 = _interopRequireDefault(_mixinsCollapseMixin);

var AccordionItem = (function (_React$Component) {
    _inherits(AccordionItem, _React$Component);

    function AccordionItem(props) {
        _classCallCheck(this, AccordionItem);

        _get(Object.getPrototypeOf(AccordionItem.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        for (var x in _mixinsCollapseMixin2['default']) {
            this[x] = _mixinsCollapseMixin2['default'][x].bind(this);
        }
        this.state = {
            collapsing: false
        };
        this.componentDidMount = this.componentDidMount.bind(this);
        this.componentWillUnmount = this.componentWillUnmount.bind(this);
        this.handleToggle = this.handleToggle.bind(this);
        this.getCollapsibleDimensionValue = this.getCollapsibleDimensionValue.bind(this);
        this.getCollapsibleDOMNode = this.getCollapsibleDOMNode.bind(this);
    }

    _createClass(AccordionItem, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.mounted = true;
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.mounted = false;
        }
    }, {
        key: 'handleToggle',
        value: function handleToggle() {
            this.setState({ expanded: !this.state.expanded });
        }
    }, {
        key: 'getCollapsibleDimensionValue',
        value: function getCollapsibleDimensionValue() {
            return _reactDom2['default'].findDOMNode(this.refs.panel).scrollHeight;
        }
    }, {
        key: 'getCollapsibleDOMNode',
        value: function getCollapsibleDOMNode() {
            if (!this.mounted || !this.refs || !this.refs.panel) {
                return null;
            }

            return _reactDom2['default'].findDOMNode(this.refs.panel);
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2['default'].createElement(
                'dl',
                { className: (0, _classnames2['default'])(this.setClassNamespace('accordion-item'), this.isExpanded() ? this.setClassNamespace('active') : null, this.props.expanded ? this.setClassNamespace('disabled') : null) },
                _react2['default'].createElement(
                    'dt',
                    {
                        onClick: this.handleToggle,
                        className: this.setClassNamespace('accordion-title') },
                    this.props.title
                ),
                _react2['default'].createElement(
                    'dd',
                    {
                        className: (0, _classnames2['default'])(this.getCollapsibleClassSet()),
                        ref: 'panel' },
                    _react2['default'].createElement('div', {
                        className: this.setClassNamespace('accordion-content'),
                        dangerouslySetInnerHTML: { __html: this.props.children } })
                )
            );
        }
    }]);

    return AccordionItem;
})(_react2['default'].Component);

AccordionItem.displayName = "AccordionItem";

AccordionItem.propTypes = {
    title: _react2['default'].PropTypes.node,
    expanded: _react2['default'].PropTypes.bool
};

AccordionItem.defaultProps = {
    classPrefix: 'accordion',
    theme: 'default'
};

module.exports = AccordionItem;