'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

//import classNames from 'classnames';

var _utilsCSSCore = require('./utils/CSSCore');

var _utilsCSSCore2 = _interopRequireDefault(_utilsCSSCore);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var _buttonGroupJsx = require('./buttonGroup.js');

var _buttonGroupJsx2 = _interopRequireDefault(_buttonGroupJsx);

var _constantsJsx = require('./constants.js');

var _constantsJsx2 = _interopRequireDefault(_constantsJsx);

var ButtonCheck = (function (_React$Component) {
    _inherits(ButtonCheck, _React$Component);

    function ButtonCheck(props) {
        _classCallCheck(this, ButtonCheck);

        _get(Object.getPrototypeOf(ButtonCheck.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
    }

    _createClass(ButtonCheck, [{
        key: 'handleClick',
        value: function handleClick(e) {
            var changed = true;
            var target = e.target;
            var activeClassName = _constantsJsx2['default'].CLASSES.active;

            if (target && target.nodeName === 'INPUT') {
                var _parent = target.parentNode;

                if (target.type === 'radio') {
                    if (target.checked && _utilsCSSCore2['default'].hasClass(_parent, activeClassName)) {
                        changed = false;
                    } else {
                        var siblings = _parent.parentNode.children;

                        // remove siblings activeClassName
                        for (var i = 0; i < siblings.length; i++) {
                            siblings[i] !== _parent && _utilsCSSCore2['default'].removeClass(siblings[i], activeClassName);
                        }
                    }
                }

                if (changed) {
                    _utilsCSSCore2['default'].toggleClass(_parent, activeClassName);
                }
            }

            this.props.clickHandler.call(this);
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2['default'].createElement(
                _buttonGroupJsx2['default'],
                _extends({}, this.props, {
                    onClick: this.handleClick.bind(this),
                    className: this.setClassNamespace('btn-group-check') }),
                this.props.children
            );
        }
    }]);

    return ButtonCheck;
})(_react2['default'].Component);

ButtonCheck.displayName = "ButtonCheck";

ButtonCheck.propTypes = {
    clickHandler: _react2['default'].PropTypes.func
};

ButtonCheck.defaultProps = {
    clickHandler: function clickHandler() {}
};

module.exports = ButtonCheck;