'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _utilsEvents = require('./utils/Events');

var _utilsEvents2 = _interopRequireDefault(_utilsEvents);

var _fecha = require('fecha');

var _fecha2 = _interopRequireDefault(_fecha);

var _utilsIsNodeInTree = require('./utils/isNodeInTree');

var _utilsIsNodeInTree2 = _interopRequireDefault(_utilsIsNodeInTree);

var _inputJsx = require('./input.js');

var _inputJsx2 = _interopRequireDefault(_inputJsx);

var _dateTimePickerJsx = require('./dateTimePicker.js');

var _dateTimePickerJsx2 = _interopRequireDefault(_dateTimePickerJsx);

var DateTimeInput = (function (_React$Component) {
    _inherits(DateTimeInput, _React$Component);

    function DateTimeInput(props) {
        _classCallCheck(this, DateTimeInput);

        _get(Object.getPrototypeOf(DateTimeInput.prototype), 'constructor', this).call(this, props);

        this.state = {
            value: this.props.dateTime || _fecha2['default'].format(new Date(), this.props.format),
            showPicker: false
        };

        this.handleOuterClick = this.handleOuterClick.bind(this);
        this.handleClose = this.handleClose.bind(this);
        this.handleClick = this.handleClick.bind(this);
        this.handleChange = this.handleChange.bind(this);
        this.handleSelect = this.handleSelect.bind(this);
        this.renderPicker = this.renderPicker.bind(this);
    }

    _createClass(DateTimeInput, [{
        key: 'handleOuterClick',
        value: function handleOuterClick(event) {
            var picker = _reactDom2['default'].findDOMNode(this.refs.DateTimePicker);

            if (!(0, _utilsIsNodeInTree2['default'])(event.target, picker)) {
                this.handleClose();
            }
        }
    }, {
        key: 'bindOuterHandlers',
        value: function bindOuterHandlers() {
            _utilsEvents2['default'].on(document, 'click', this.handleOuterClick);
        }
    }, {
        key: 'unbindOuterHandlers',
        value: function unbindOuterHandlers() {
            _utilsEvents2['default'].off(document, 'click', this.handleOuterClick);
        }
    }, {
        key: 'handleClose',
        value: function handleClose() {
            this.unbindOuterHandlers();
            return this.setState({
                showPicker: false
            });
        }
    }, {
        key: 'handleClick',
        value: function handleClick() {
            this.bindOuterHandlers();
            var posObj = this.refs.dateInput.getFieldDOMNode();

            var offset = {
                top: posObj.offsetTop + posObj.offsetHeight,
                left: posObj.offsetLeft
            };

            var styles = {
                display: 'block',
                top: offset.top,
                left: offset.left,
                position: 'absolute',
                zIndex: 1120
            };

            this.setState({
                showPicker: true,
                pickerStyle: styles
            });
        }
    }, {
        key: 'handleChange',
        value: function handleChange(event) {
            return this.setState({
                value: event.target.value
            });
        }
    }, {
        key: 'handleSelect',
        value: function handleSelect(date) {
            return this.setState({
                value: date
            });
        }
    }, {
        key: 'renderPicker',
        value: function renderPicker() {
            if (this.state.showPicker) {
                return _react2['default'].createElement(_dateTimePickerJsx2['default'], {
                    style: this.state.pickerStyle,
                    ref: 'DateTimePicker',
                    showDatePicker: this.props.showDatePicker,
                    showTimePicker: this.props.showTimePicker,
                    onSelect: this.handleSelect,
                    onClose: this.handleClose,
                    amStyle: this.props.amStyle,
                    dateTime: this.state.value,
                    viewMode: this.props.viewMode,
                    minViewMode: this.props.minViewMode,
                    daysOfWeekDisabled: this.props.daysOfWeekDisabled,
                    weekStart: this.props.weekStart,
                    format: this.props.format,
                    locale: this.props.locale,
                    maxDate: this.props.maxDate,
                    minDate: this.props.minDate });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2['default'].createElement(
                'div',
                null,
                _react2['default'].createElement(_inputJsx2['default'], _extends({}, this.props, {
                    type: 'text',
                    onClick: this.handleClick,
                    value: this.state.value,
                    onChange: this.handleChange,
                    ref: 'dateInput' })),
                this.renderPicker()
            );
        }
    }]);

    return DateTimeInput;
})(_react2['default'].Component);

DateTimeInput.displayName = "DateTimeInput";

DateTimeInput.propTypes = {
    format: _react2['default'].PropTypes.string,
    dateTime: _react2['default'].PropTypes.string
};

DateTimeInput.defaultProps = {
    dateTime: '',
    format: 'YYYY-MM-DD HH:mm'
};

module.exports = DateTimeInput;

// TODO: ����