'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var _mixinsConstantsJs = require('./mixins/constants.js');

var _mixinsConstantsJs2 = _interopRequireDefault(_mixinsConstantsJs);

var _buttonJsx = require('./button.js');

var _buttonJsx2 = _interopRequireDefault(_buttonJsx);

var _iconJsx = require('./icon.js');

var _iconJsx2 = _interopRequireDefault(_iconJsx);

var _utilsEvents = require('./utils/Events');

var _utilsEvents2 = _interopRequireDefault(_utilsEvents);

var _utilsIsNodeInTreeJs = require('./utils/isNodeInTree.js');

var _utilsIsNodeInTreeJs2 = _interopRequireDefault(_utilsIsNodeInTreeJs);

var Dropdown = (function (_React$Component) {
    _inherits(Dropdown, _React$Component);

    function Dropdown(props) {
        _classCallCheck(this, Dropdown);

        _get(Object.getPrototypeOf(Dropdown.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.state = {
            open: false
        };

        this.setDropdownState = this.setDropdownState.bind(this);
        this.handleDropdownClick = this.handleDropdownClick.bind(this);
        this.handleOuterClick = this.handleOuterClick.bind(this);
        this.bindOuterHandlers = this.bindOuterHandlers.bind(this);
        this.handleKeyup = this.handleKeyup.bind(this);
    }

    _createClass(Dropdown, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.unbindOuterHandlers();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.unbindOuterHandlers();
        }
    }, {
        key: 'setDropdownState',
        value: function setDropdownState(state, callback) {
            if (state) {
                this.bindOuterHandlers();
            } else {
                this.unbindOuterHandlers();
            }

            this.setState({
                open: state
            }, function () {
                callback && callback();

                state && this.props.onOpen && this.props.onOpen();
                !state && this.props.onClose && this.props.onClose();
            });
        }

        // close dropdown on `esc` keyup
    }, {
        key: 'handleKeyup',
        value: function handleKeyup(e) {
            e.keyCode === 27 && this.setDropdownState(false);
        }

        // close dropdown when click outer dropdown
    }, {
        key: 'handleOuterClick',
        value: function handleOuterClick(e) {
            if ((0, _utilsIsNodeInTreeJs2['default'])(e.target, _reactDom2['default'].findDOMNode(this))) {
                return false;
            }

            this.setDropdownState(false);
        }
    }, {
        key: 'bindOuterHandlers',
        value: function bindOuterHandlers() {
            _utilsEvents2['default'].on(document, 'click', this.handleOuterClick);
            _utilsEvents2['default'].on(document, 'keyup', this.handleKeyup);
        }
    }, {
        key: 'unbindOuterHandlers',
        value: function unbindOuterHandlers() {
            _utilsEvents2['default'].off(document, 'click', this.handleOuterClick);
            _utilsEvents2['default'].off(document, 'keyup', this.handleKeyup);
        }
    }, {
        key: 'handleDropdownClick',
        value: function handleDropdownClick(e) {
            e.preventDefault();
            this.setDropdownState(!this.state.open);
        }
    }, {
        key: 'render',
        value: function render() {
            var classSet = this.getClassSet();
            var Component = this.props.navItem ? 'li' : 'div';
            var caret = _react2['default'].createElement(_iconJsx2['default'], {
                className: this.props.caretClassName,
                icon: 'caret-' + (this.props.dropup ? 'up' : 'down') });
            var animation = this.state.open ? this.setClassNamespace('animation-slide-top-fixed') : this.setClassNamespace('dropdown-animation');
            var ContentTag = this.props.contentTag;

            classSet[_mixinsConstantsJs2['default'].CLASSES.active] = this.state.open;
            classSet[this.prefixClass('up')] = this.props.dropup;

            return _react2['default'].createElement(
                Component,
                {
                    btnStyle: null,
                    className: (0, _classnames2['default'])(this.props.className, classSet) },
                _react2['default'].createElement(
                    _buttonJsx2['default'],
                    {
                        onClick: this.handleDropdownClick,
                        amStyle: this.props.btnStyle,
                        style: this.props.btnInlineStyle,
                        className: (0, _classnames2['default'])(this.prefixClass('toggle'), this.props.toggleClassName),
                        ref: 'dropdownToggle' },
                    this.props.title,
                    ' ',
                    caret
                ),
                _react2['default'].createElement(
                    ContentTag,
                    {
                        ref: 'dropdownContent',
                        style: this.props.contentInlineStyle,
                        className: (0, _classnames2['default'])(this.prefixClass('content'), animation, this.props.contentClassName) },
                    this.props.children
                )
            );
        }
    }]);

    return Dropdown;
})(_react2['default'].Component);

Dropdown.displayName = "Dropdown";

Dropdown.propTypes = {
    title: _react2['default'].PropTypes.node.isRequired,
    dropup: _react2['default'].PropTypes.bool,
    navItem: _react2['default'].PropTypes.bool,
    btnStyle: _react2['default'].PropTypes.string,
    btnInlineStyle: _react2['default'].PropTypes.object,
    contentInlineStyle: _react2['default'].PropTypes.object,
    contentTag: _react2['default'].PropTypes.node,
    toggleClassName: _react2['default'].PropTypes.string,
    caretClassName: _react2['default'].PropTypes.string,
    contentClassName: _react2['default'].PropTypes.string,
    onOpen: _react2['default'].PropTypes.func, // open callback
    onClose: _react2['default'].PropTypes.func };

// close callback
Dropdown.defaultProps = {
    classPrefix: 'dropdown',
    contentTag: 'ul'
};

module.exports = Dropdown;

/*
 * TODO:
 *   1. �رն���
 *   2. λ�ü���/������Ӧ
 * */