'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var _buttonJsx = require('./button.js');

var _buttonJsx2 = _interopRequireDefault(_buttonJsx);

var _colJsx = require('./col.js');

var _colJsx2 = _interopRequireDefault(_colJsx);

var ListNews = (function (_React$Component) {
    _inherits(ListNews, _React$Component);

    function ListNews(props) {
        _classCallCheck(this, ListNews);

        _get(Object.getPrototypeOf(ListNews.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.renderHeader = this.renderHeader.bind(this);
        this.renderFooter = this.renderFooter.bind(this);
        this.getListItemClasses = this.getListItemClasses.bind(this);
        this.renderBody = this.renderBody.bind(this);
        this.renderList = this.renderList.bind(this);
        this.renderItemMisc = this.renderItemMisc.bind(this);
        this.renderItemThumb = this.renderItemThumb.bind(this);
        this.renderItemMain = this.renderItemMain.bind(this);

        this._onItemMainClick = this._onItemMainClick.bind(this);
        this._onMoreClick = this._onMoreClick.bind(this);
    }

    _createClass(ListNews, [{
        key: 'renderHeader',
        value: function renderHeader() {
            var data = this.props.data;

            return data && data.header && data.header.title ? _react2['default'].createElement(
                'div',
                {
                    className: (0, _classnames2['default'])(this.prefixClass('hd'), this.setClassNamespace('cf')) },
                data.header.link ? _react2['default'].createElement(
                    'a',
                    { href: data.header.link, onTouchTap: this._onMoreClick },
                    _react2['default'].createElement(
                        'h2',
                        null,
                        data.header.title
                    ),
                    this.props.morePosition === 'top' ? _react2['default'].createElement(
                        'span',
                        {
                            className: (0, _classnames2['default'])(this.prefixClass('more'), this.setClassNamespace('fr')) },
                        this.props.moreTextTitle,
                        this.props.moreText
                    ) : null
                ) : _react2['default'].createElement(
                    'h2',
                    null,
                    data.header.title
                )
            ) : null;
        }

        // `more` on bottom
    }, {
        key: 'renderFooter',
        value: function renderFooter() {
            var showMore = this.props.showFooterMore ? "block" : "none";
            return this.props.morePosition === 'bottom' && this.props.data.header.link ? _react2['default'].createElement(
                'div',
                { className: this.prefixClass('ft'), style: { display: showMore } },
                _react2['default'].createElement(
                    _buttonJsx2['default'],
                    {
                        className: this.prefixClass('more'),
                        href: this.props.data.header.link,
                        onTouchTap: this._onMoreClick },
                    this.props.moreTextTitle,
                    this.props.moreText
                )
            ) : null;
        }
    }, {
        key: 'getListItemClasses',
        value: function getListItemClasses(item) {
            return (0, _classnames2['default'])(this.setClassNamespace('g'), item.date ? this.setClassNamespace('list-item-dated') : false, item.desc ? this.setClassNamespace('list-item-desced') : false, item.img ? this.setClassNamespace('list-item-thumbed') : false, this.props.thumbPosition ? this.setClassNamespace('list-item-thumb-' + this.props.thumbPosition) : false);
        }
    }, {
        key: 'renderBody',
        value: function renderBody(children) {
            return _react2['default'].createElement(
                'div',
                { className: this.prefixClass('bd') },
                _react2['default'].createElement(
                    'ul',
                    { className: this.setClassNamespace('list') },
                    children
                )
            );
        }

        //生成列表主题
    }, {
        key: 'renderList',
        value: function renderList() {
            var position = this.props.thumbPosition; //定义略缩图位置

            var orderChildren = (function (item, i) {
                var thumb = this.renderItemThumb(item, i); //生成略缩图
                var main = this.renderItemMain(item, i); //生成主题内容
                //也就是说，图片默认位置为“left”,"bottom-left".
                //注意这里生成的main ,还需要判断是否需要再生成标题。判断为"left","right"的情况下才生成标题
                return position === 'right' || position === 'bottom-right' ? [main, thumb] : [thumb, main];
            }).bind(this);

            //判断略缩图，如果在标题下面的话，则生成H3 标题。 如果标题和略缩图平级，则不生成顶部标题。
            return this.props.data.main.map((function (item, i) {
                return _react2['default'].createElement(
                    'li',
                    {
                        key: i,
                        className: this.getListItemClasses(item) },
                    position === 'bottom-left' || position === 'bottom-right' ? this.renderThumbItemTitle(item) : null,
                    orderChildren(item, i)
                );
            }).bind(this));
        }

        //根据传入data 中的 tag 生成相对应的标签，只生成用于展示的标签部分
    }, {
        key: 'renderItemMisc',
        value: function renderItemMisc(item, type) {
            var Tag = type === 'date' ? 'span' : 'div';
            var className = undefined;

            switch (type) {
                case 'date':
                    //日期
                    className = 'list-date';
                    break;
                case 'desc':
                    //详情描述
                    className = 'list-item-text';
                    break;
                case 'mainAddition':
                    //生成主要内容
                    className = 'list-news-addon';
                    break;
                case 'thumbAddition':
                    className = 'list-thumb-addon';
            }

            return item[type] ? _react2['default'].createElement(
                Tag,
                { className: this.setClassNamespace(className) },
                item[type]
            ) : null;
        }

        //生成功能按钮
    }, {
        key: 'renderItemBtn',
        value: function renderItemBtn(item, type) {

            var className = undefined,
                eventName = undefined;

            switch (type) {
                case 'delete':
                    //日期
                    className = 'list-btn-delete';
                    eventName = '_onTouchTapDelete';
                    break;
            }

            return item[type] ? _react2['default'].createElement(
                'a',
                { href: '##',
                    className: this.setClassNamespace(className),
                    onTouchTap: this[eventName].bind(this, item) },
                item[type]
            ) : null;
        }

        //略缩图
    }, {
        key: 'renderItemThumb',
        value: function renderItemThumb(item, i) {
            var cols = this.props.thumbPosition === 'top' ? 12 : 4;

            return item.img ? _react2['default'].createElement(
                _colJsx2['default'],
                {
                    key: 'thumb' + i,
                    sm: cols,
                    className: this.setClassNamespace('list-thumb') },
                _react2['default'].createElement(
                    'a',
                    { href: item.link, onTouchTap: this._onItemMainClick.bind(this, item) },
                    _react2['default'].createElement('img', { src: item.img, alt: item.title })
                ),
                this.renderItemMisc(item, 'thumbAddition')
            ) : null;
        }

        //主要的列表
    }, {
        key: 'renderItemMain',
        value: function renderItemMain(item, i) {

            var position = this.props.thumbPosition; //略缩图的位置
            var date = this.renderItemMisc(item, 'date'); //生成日期
            var desc = this.renderItemMisc(item, 'desc'); //生成标题
            var addon = this.renderItemMisc(item, 'mainAddition'); //生成主要内容
            var deleteFn = this.renderItemBtn(item, 'delete'); //生成主要内容

            // 如果没有设置 position 值，则不生成略缩图
            var itemWithoutThumbTitle = !position && item.title ? _react2['default'].createElement(
                'a',
                {
                    key: 'title' + i,
                    className: this.setClassNamespace('list-item-hd'),
                    href: item.link },
                item.title
            ) : null;

            //其实这里是生成栅格的，但是不需要怎么办
            // top 的话就是 12， 其余的看是否有图片，有图片的就是8， 没有的话就是12
            var cols = position === 'top' ? 12 : item.img ? 8 : 12;

            //有略缩图的话就生成略缩图，没有的话只生成标题等
            return position ? _react2['default'].createElement(
                _colJsx2['default'],
                {
                    sm: cols,
                    className: this.setClassNamespace('list-main'),
                    key: 'itemMain' + i },
                position !== 'bottom-left' && position !== 'bottom-right' ? this.renderThumbItemTitle(item) : null,
                desc,
                date,
                addon,
                _react2['default'].createElement(
                    'div',
                    { className: this.setClassNamespace('list-btn') },
                    deleteFn
                )
            ) : [itemWithoutThumbTitle, date, desc, addon];
        }

        //图片在标题下面时（”bottom- “），生成文章标题
    }, {
        key: 'renderThumbItemTitle',
        value: function renderThumbItemTitle(item) {
            return item.title ? _react2['default'].createElement(
                'h3',
                { className: this.setClassNamespace('list-item-hd') },
                _react2['default'].createElement(
                    'a',
                    {
                        href: item.link,
                        onTouchTap: this._onItemMainClick.bind(this, item) },
                    item.title
                )
            ) : null;
        }

        //文章点击事件
    }, {
        key: '_onItemMainClick',
        value: function _onItemMainClick(item, e) {
            if (this.props.onTouchTapTitle) {
                e.stopPropagation();
                e.preventDefault();
                this.props.onTouchTapTitle(item, e);
            }
        }

        //more 按钮点击事件
    }, {
        key: '_onMoreClick',
        value: function _onMoreClick(e) {
            if (this.props.onTouchTapMore) {
                e.stopPropagation();
                e.preventDefault();
                this.props.onTouchTapMore(e);
            }
        }
    }, {
        key: '_onTouchTapDelete',
        value: function _onTouchTapDelete(item, e) {
            if (this.props.onTouchTapDelete) {
                e.stopPropagation();
                e.preventDefault();
                this.props.onTouchTapDelete(item, e);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var classSet = this.getClassSet();

            return _react2['default'].createElement(
                'div',
                _extends({}, this.props, {
                    'data-widget': this.props.classPrefix,
                    className: (0, _classnames2['default'])(this.props.className, classSet) }),
                this.props.header || this.renderHeader(),
                this.renderBody(this.renderList()),
                this.props.footer || this.renderFooter()
            );
        }
    }]);

    return ListNews;
})(_react2['default'].Component);

ListNews.displayName = "ListNews";

ListNews.propTypes = {
    classPrefix: _react2['default'].PropTypes.string,
    theme: _react2['default'].PropTypes.oneOf(['default']),
    data: _react2['default'].PropTypes.object,
    header: _react2['default'].PropTypes.node,
    footer: _react2['default'].PropTypes.node,
    morePosition: _react2['default'].PropTypes.oneOf(['top', 'bottom']),
    moreText: _react2['default'].PropTypes.string,
    thumbPosition: _react2['default'].PropTypes.oneOf(['top', 'left', 'right', 'bottom-left', 'bottom-right'])
};

ListNews.defaultProps = {
    classPrefix: 'list-news',
    theme: 'default',
    moreText: ' »'
};

module.exports = ListNews;