'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

var nsPrefix = _constants2['default'].NAMESPACE ? _constants2['default'].NAMESPACE + '-' : '';

module.exports = {
    getClassSet: function getClassSet(ignorePrefix) {
        var classNames = {};
        // uses `.am-` as prefix if `classPrefix` is not defined
        var prefix = nsPrefix;

        if (this.props.classPrefix) {
            var classPrefix = this.setClassNamespace();

            prefix = classPrefix + '-';

            // don't return prefix if flag set
            !ignorePrefix && (classNames[classPrefix] = true);
        }

        var amSize = this.props.amSize;
        var amStyle = this.props.amStyle;

        if (amSize) {
            classNames[prefix + amSize] = true;
        }

        if (amStyle) {
            classNames[prefix + amStyle] = true;
        }

        // add theme className for widgets
        if (this.props.theme) {
            classNames[prefix + this.props.theme] = true;
        }

        // states
        classNames[_constants2['default'].CLASSES.active] = this.props.active;
        classNames[_constants2['default'].CLASSES.disabled] = this.props.disabled;

        // shape
        classNames[_constants2['default'].CLASSES.radius] = this.props.radius;
        classNames[_constants2['default'].CLASSES.round] = this.props.round;

        // clearfix
        classNames[_constants2['default'].CLASSES.cf] = this.props.cf;

        // am-divider
        if (this.props.classPrefix !== 'divider') {
            classNames[_constants2['default'].CLASSES.divider] = this.props.divider;
        }

        return classNames;
    },

    // add namespace to classPrefix
    setClassNamespace: function setClassNamespace(classPrefix) {
        var prefix = classPrefix || this.props.classPrefix || '';

        return nsPrefix + prefix;
    },

    prefixClass: function prefixClass(subClass) {
        return this.setClassNamespace() + '-' + subClass;
    }
};