'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utilsGetScrollbarWidth = require('../utils/getScrollbarWidth');

var _utilsGetScrollbarWidth2 = _interopRequireDefault(_utilsGetScrollbarWidth);

var _utilsCSSCore = require('../utils/CSSCore');

var _utilsCSSCore2 = _interopRequireDefault(_utilsCSSCore);

module.exports = {
    setDimmerContainer: function setDimmerContainer() {
        var container = this.props.container && _reactDom2['default'].findDOMNode(this.props.container) || document.body;
        var bodyPaddingRight = parseInt(container.style.paddingRight || 0, 10);
        var barWidth = (0, _utilsGetScrollbarWidth2['default'])();

        if (barWidth) {
            container.style.paddingRight = bodyPaddingRight + barWidth + 'px';
        }

        _utilsCSSCore2['default'].addClass(container, this.setClassNamespace('dimmer-active'));
    },

    resetDimmerContainer: function resetDimmerContainer() {
        var container = this.props.container && _reactDom2['default'].findDOMNode(this.props.container) || document.body;

        _utilsCSSCore2['default'].removeClass(container, this.setClassNamespace('dimmer-active'));

        container.style.paddingRight = '';
    },

    renderDimmer: function renderDimmer(children) {
        var onClick = this.handleDimmerClick || null;
        var classSet = {};

        classSet[this.setClassNamespace('dimmer')] = true;
        classSet[this.setClassNamespace('active')] = true;

        return React.createElement(
            'div',
            null,
            React.createElement('div', {
                onClick: onClick,
                ref: 'dimmer',
                style: { display: 'block' },
                className: (0, _classnames2['default'])(classSet) }),
            children
        );
    }
};