'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mixinsOverlayMixin = require('./mixins/OverlayMixin');

var _mixinsOverlayMixin2 = _interopRequireDefault(_mixinsOverlayMixin);

var _mixinsDimmerMixin = require('./mixins/DimmerMixin');

var _mixinsDimmerMixin2 = _interopRequireDefault(_mixinsDimmerMixin);

var _utilsCreateChainedFunction = require('./utils/createChainedFunction');

var _utilsCreateChainedFunction2 = _interopRequireDefault(_utilsCreateChainedFunction);

var cloneElement = _react2['default'].cloneElement;

var ModalTrigger = (function (_React$Component) {
    _inherits(ModalTrigger, _React$Component);

    function ModalTrigger(props) {
        _classCallCheck(this, ModalTrigger);

        _get(Object.getPrototypeOf(ModalTrigger.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsOverlayMixin2['default']) {
            this[v] = _mixinsOverlayMixin2['default'][v].bind(this);
        }
        for (var b in _mixinsDimmerMixin2['default']) {
            this[b] = _mixinsDimmerMixin2['default'][b].bind(this);
        }
        this.state = {
            isModalActive: false,
            modalWidth: null,
            modalMarginLeft: null,
            modalHeight: null,
            modalMarginTop: null
        };

        this.open = this.open.bind(this);
        this.close = this.close.bind(this);
        this.toggle = this.toggle.bind(this);
        this.setModalStyle = this.setModalStyle.bind(this);
        this.renderOverlay = this.renderOverlay.bind(this);
    }

    _createClass(ModalTrigger, [{
        key: 'open',
        value: function open() {
            this.setState({
                isModalActive: true
            }, this.setModalStyle);
        }
    }, {
        key: 'close',
        value: function close() {
            this.setState({
                isModalActive: false
            });
        }
    }, {
        key: 'toggle',
        value: function toggle() {
            if (this.state.isModalActive) {
                this.close();
            } else {
                this.open();
            }
        }

        //���õ�������ʽ
    }, {
        key: 'setModalStyle',
        value: function setModalStyle() {

            // TODO: selector
            var modal = this.getOverlayDOMNode().querySelector('.modal');

            if (!modal) {
                return;
            }

            var style = {};

            if (this.props.modalHeight) {
                style.modalHeight = this.props.modalHeight;
                style.modalMarginTop = -this.props.height / 2;
            } else {
                style.modalMarginTop = -modal.offsetHeight / 2;
            }

            if (this.props.modalWidth) {
                style.modalWidth = this.props.modalWidth;
                style.modalMarginLeft = -this.props.modalWidth / 2;
            }

            this.setState(style);
        }

        // overlay is the modal
    }, {
        key: 'renderOverlay',
        value: function renderOverlay() {
            if (!this.state.isModalActive) {
                return _react2['default'].createElement('span', null);
            }
            //����modal
            return cloneElement(this.props.modal, {
                onRequestClose: this.close,
                marginTop: this.state.modalMarginTop,
                marginLeft: this.state.modalMarginLeft,
                modalWidth: this.state.modalWidth,
                modalHeight: this.state.modalHeight,
                title: this.props.modal.props.title || this.props.title,
                onConfirm: (0, _utilsCreateChainedFunction2['default'])(this.close, this.props.onConfirm),
                onCancel: (0, _utilsCreateChainedFunction2['default'])(this.close, this.props.onCancel)
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var child = _react2['default'].Children.only(this.props.children);
            var props = {};
            //������Ϊ ModalTrigger ������������Ԫ�أ����� button �ȣ����� �����¼�
            props.onTouchTap = (0, _utilsCreateChainedFunction2['default'])(child.props.onTouchTap, this.toggle);
            /* props.onTouchStart = createChainedFunction(child.props.onTouchStart, this.toggle);*/
            props.onMouseOver = (0, _utilsCreateChainedFunction2['default'])(child.props.onMouseOver, this.props.onMouseOver);
            props.onMouseOut = (0, _utilsCreateChainedFunction2['default'])(child.props.onMouseOut, this.props.onMouseOut);
            props.onFocus = (0, _utilsCreateChainedFunction2['default'])(child.props.onFocus, this.props.onFocus);
            props.onBlur = (0, _utilsCreateChainedFunction2['default'])(child.props.onBlur, this.props.onBlur);

            return cloneElement(child, props);
        }
    }]);

    return ModalTrigger;
})(_react2['default'].Component);

ModalTrigger.displayName = "ModalTrigger";

ModalTrigger.propTypes = {
    modal: _react2['default'].PropTypes.node.isRequired,
    onConfirm: _react2['default'].PropTypes.func,
    onCancel: _react2['default'].PropTypes.func,
    title: _react2['default'].PropTypes.string
};

ModalTrigger.defaultProps = {
    test: ''
};

module.exports = ModalTrigger;