'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var _mixinsCollapseMixin = require('./mixins/CollapseMixin');

var _mixinsCollapseMixin2 = _interopRequireDefault(_mixinsCollapseMixin);

var Panel = (function (_React$Component) {
    _inherits(Panel, _React$Component);

    function Panel(props) {
        _classCallCheck(this, Panel);

        _get(Object.getPrototypeOf(Panel.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        for (var c in _mixinsCollapseMixin2['default']) {
            this[c] = _mixinsCollapseMixin2['default'][c].bind(this);
        }
        this.state = {
            expanded: true
        };

        this.handleToggle = this.handleToggle.bind(this);
        this.getCollapsibleDimensionValue = this.getCollapsibleDimensionValue.bind(this);
        this.getCollapsibleDOMNode = this.getCollapsibleDOMNode.bind(this);
        this.renderHeader = this.renderHeader.bind(this);
        this.renderBody = this.renderBody.bind(this);
        this.renderCollapsibleBody = this.renderCollapsibleBody.bind(this);
        this.renderFooter = this.renderFooter.bind(this);
    }

    _createClass(Panel, [{
        key: 'handleClick',
        value: function handleClick(e) {
            e.selected = true;

            if (this.props.onSelect) {
                this.props.onSelect(e, this.props.eventKey);
            } else {
                e.preventDefault();
            }

            if (e.selected) {
                this.handleToggle();
            }
        }
    }, {
        key: 'handleToggle',
        value: function handleToggle() {
            this.setState({ expanded: !this.state.expanded });
        }
    }, {
        key: 'getCollapsibleDimensionValue',
        value: function getCollapsibleDimensionValue() {
            return _reactDom2['default'].findDOMNode(this.refs.panel).scrollHeight;
        }
    }, {
        key: 'getCollapsibleDOMNode',
        value: function getCollapsibleDOMNode() {
            if (!this.isMounted || !this.refs || !this.refs.panel) {
                return null;
            }

            return _reactDom2['default'].findDOMNode(this.refs.panel);
        }
    }, {
        key: 'renderHeader',
        value: function renderHeader() {
            if (!this.props.header) {
                return null;
            }

            var header = this.props.header;

            return _react2['default'].createElement(
                'div',
                { className: this.prefixClass('hd') },
                this.props.collapsible ? _react2['default'].createElement(
                    'h4',
                    {
                        'data-collapse': true, // just for `pointer` style
                        className: (0, _classnames2['default'])(this.prefixClass('title'), this.isExpanded() ? null : this.setClassNamespace('collapsed')),
                        onClick: this.handleClick.bind(this) },
                    header
                ) : header
            );
        }
    }, {
        key: 'renderBody',
        value: function renderBody() {
            var bodyClass = this.prefixClass('bd');
            var bodyChildren = this.props.children;
            var bodyElements = [];
            var panelBodyChildren = [];

            function getProps() {
                return {
                    key: bodyElements.length
                };
            }

            function addFillChild(child) {
                bodyElements.push(_react2['default'].cloneElement(child, getProps()));
            }

            function addPanelBody(child) {
                bodyElements.push(_react2['default'].createElement(
                    'div',
                    _extends({ className: bodyClass }, getProps, { key: 'panelBody' }),
                    child
                ));
            }

            function maybeRenderPanelBody() {
                if (panelBodyChildren.length === 0) {
                    return;
                }

                addPanelBody(panelBodyChildren);
                panelBodyChildren = [];
            }

            if (Array.isArray(bodyChildren)) {
                bodyChildren.forEach((function (child) {
                    // props fill and isValidElement
                    if (this.shouldRenderFill(child)) {
                        maybeRenderPanelBody();

                        addFillChild(child);
                    } else {
                        panelBodyChildren.push(child);
                    }
                }).bind(this));

                maybeRenderPanelBody();
            } else {
                if (this.shouldRenderFill(bodyChildren)) {
                    addFillChild(bodyChildren);
                } else {
                    addPanelBody(bodyChildren);
                }
            }

            return bodyElements;
        }
    }, {
        key: 'renderCollapsibleBody',
        value: function renderCollapsibleBody() {
            var collapseClass = this.prefixClass('collapse');

            return _react2['default'].createElement(
                'div',
                {
                    className: (0, _classnames2['default'])(this.getCollapsibleClassSet(collapseClass)),
                    id: this.props.id,
                    ref: 'panel' },
                this.renderBody()
            );
        }
    }, {
        key: 'shouldRenderFill',
        value: function shouldRenderFill(child) {
            return _react2['default'].isValidElement(child) && child.props.fill;
        }
    }, {
        key: 'renderFooter',
        value: function renderFooter() {
            if (!this.props.footer) {
                return null;
            }

            return _react2['default'].createElement(
                'div',
                { className: this.prefixClass('footer') },
                this.props.footer
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var classes = this.getClassSet();
            var collapsible = this.props.collapsible;

            return _react2['default'].createElement(
                'div',
                _extends({}, this.props, {
                    id: collapsible ? null : this.props.id,
                    className: (0, _classnames2['default'])(classes, this.props.className) }),
                this.renderHeader(),
                collapsible ? this.renderCollapsibleBody() : this.renderBody(),
                this.renderFooter()
            );
        }
    }]);

    return Panel;
})(_react2['default'].Component);

Panel.displayName = "Panel";

Panel.propTypes = {
    collapsible: _react2['default'].PropTypes.bool,
    header: _react2['default'].PropTypes.node,
    footer: _react2['default'].PropTypes.node,
    id: _react2['default'].PropTypes.string,
    amStyle: _react2['default'].PropTypes.string,
    onSelect: _react2['default'].PropTypes.func,
    eventKey: _react2['default'].PropTypes.any
};

Panel.defaultProps = {
    classPrefix: 'panel',
    amStyle: 'default'
};

module.exports = Panel;