'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var PanelGroup = (function (_React$Component) {
    _inherits(PanelGroup, _React$Component);

    function PanelGroup(props) {
        _classCallCheck(this, PanelGroup);

        _get(Object.getPrototypeOf(PanelGroup.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }

        this.state = {
            activeKey: this.props.defaultActiveKey
        };

        this.shouldComponentUpdate = this.shouldComponentUpdate.bind(this);
        this.renderPanel = this.renderPanel.bind(this);
    }

    _createClass(PanelGroup, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate() {
            return !this._isChanging;
        }
    }, {
        key: 'handleSelect',
        value: function handleSelect(e, key) {
            e.preventDefault();

            if (this.props.onSelect) {
                this._isChanging = true;
                this.props.onSelect(key);
                this._isChanging = false;
            }

            if (this.state.activeKey === key) {
                key = null;
            }

            this.setState({
                activeKey: key
            });
        }
    }, {
        key: 'renderPanel',
        value: function renderPanel(child, index) {
            var activeKey = this.props.activeKey != null ? this.props.activeKey : this.state.activeKey;

            var props = {
                amStyle: child.props.amStyle || this.props.amStyle,
                key: child.key ? child.key : index,
                ref: child.ref
            };

            if (this.props.accordion) {
                props.collapsible = true;
                props.expanded = child.props.eventKey === activeKey;
                props.onSelect = this.handleSelect.bind(this);
            }

            return _react2['default'].cloneElement(child, props);
        }
    }, {
        key: 'render',
        value: function render() {
            var classes = this.getClassSet();

            return _react2['default'].createElement(
                'div',
                _extends({}, this.props, {
                    className: (0, _classnames2['default'])(classes, this.props.className) }),
                _react2['default'].Children.map(this.props.children, this.renderPanel)
            );
        }
    }]);

    return PanelGroup;
})(_react2['default'].Component);

PanelGroup.displayName = "PanelGroup";

PanelGroup.propTypes = {
    amStyle: _react2['default'].PropTypes.string,
    activeKey: _react2['default'].PropTypes.any,
    defaultActiveKey: _react2['default'].PropTypes.any,
    onSelect: _react2['default'].PropTypes.func,
    accordion: _react2['default'].PropTypes.bool
};

PanelGroup.defaultProps = {
    classPrefix: 'panel-group'
};

module.exports = PanelGroup;