'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var _mixinsOverlayMixinJs = require('./mixins/OverlayMixin.js');

var _mixinsOverlayMixinJs2 = _interopRequireDefault(_mixinsOverlayMixinJs);

var _utilsDomUtils = require('./utils/domUtils');

var _utilsDomUtils2 = _interopRequireDefault(_utilsDomUtils);

var _utilsCreateChainedFunction = require('./utils/createChainedFunction');

var _utilsCreateChainedFunction2 = _interopRequireDefault(_utilsCreateChainedFunction);

var cloneElement = _react2['default'].cloneElement;

function isOneOf(one, of) {
    if (Array.isArray(of)) {
        return of.indexOf(one) >= 0;
    }
    return one === of;
}

var PopoverTrigger = (function (_React$Component) {
    _inherits(PopoverTrigger, _React$Component);

    function PopoverTrigger(props) {
        _classCallCheck(this, PopoverTrigger);

        _get(Object.getPrototypeOf(PopoverTrigger.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        for (var x in _mixinsOverlayMixinJs2['default']) {
            this[x] = _mixinsOverlayMixinJs2['default'][x].bind(this);
        }
        this.state = {
            isPopoverActive: this.props.defaultPopoverActive == null ? false : this.props.defaultPopoverActive,
            popoverLeft: null,
            popoverTop: null
        };

        this.componentDidMount = this.componentDidMount.bind(this);
        this.componentWillUnmount = this.componentWillUnmount.bind(this);
        this.open = this.open.bind(this);
        this.close = this.close.bind(this);
        this.toggle = this.toggle.bind(this);
        this.handleDelayedOpen = this.handleDelayedOpen.bind(this);
        this.handleDelayedClose = this.handleDelayedClose.bind(this);
        this.updatePopoverPosition = this.updatePopoverPosition.bind(this);
        this.calcPopoverPosition = this.calcPopoverPosition.bind(this);
        this.getPosition = this.getPosition.bind(this);
        this.renderOverlay = this.renderOverlay.bind(this);
    }

    _createClass(PopoverTrigger, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.props.defaultPopoverActive) {
                this.updatePopoverPosition();
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            clearTimeout(this._hoverDelay);
        }
    }, {
        key: 'open',
        value: function open() {
            this.setState({
                isPopoverActive: true
            }, function () {
                this.updatePopoverPosition();
            });
        }
    }, {
        key: 'close',
        value: function close() {
            this.setState({
                isPopoverActive: false
            });
        }
    }, {
        key: 'toggle',
        value: function toggle() {
            this.state.isPopoverActive ? this.close() : this.open();
        }
    }, {
        key: 'handleDelayedOpen',
        value: function handleDelayedOpen() {
            if (this._hoverDelay != null) {
                clearTimeout(this._hoverDelay);
                this._hoverDelay = null;
                return;
            }

            var delay = this.props.delayOpen != null ? this.props.delayOpen : this.props.delay;

            if (!delay) {
                this.open();
                return;
            }

            this._hoverDelay = setTimeout((function () {
                this._hoverDelay = null;
                this.open();
            }).bind(this), delay);
        }
    }, {
        key: 'handleDelayedClose',
        value: function handleDelayedClose() {
            if (this._hoverDelay != null) {
                clearTimeout(this._hoverDelay);
                this._hoverDelay = null;
                return;
            }

            var delay = this.props.delayClose != null ? this.props.delayClose : this.props.delay;

            if (!delay) {
                this.close();
                return;
            }

            this._hoverDelay = setTimeout((function () {
                this._hoverDelay = null;
                this.close();
            }).bind(this), delay);
        }
    }, {
        key: 'updatePopoverPosition',
        value: function updatePopoverPosition() {
            //if (!this.isMounted) {
            //    return;
            //}

            var position = this.calcPopoverPosition();

            this.setState({
                popoverLeft: position.left,
                popoverTop: position.top
            });
        }
    }, {
        key: 'calcPopoverPosition',
        value: function calcPopoverPosition() {
            var childOffset = this.getPosition();
            var popoverNode = this.getOverlayDOMNode();
            var popoverHeight = popoverNode.offsetHeight;
            var popoverWidth = popoverNode.offsetWidth;
            var caretSize = 8;

            switch (this.props.placement) {
                case 'right':
                    return {
                        top: childOffset.top + childOffset.height / 2 - popoverHeight / 2,
                        left: childOffset.left + childOffset.width + caretSize
                    };
                case 'left':
                    return {
                        top: childOffset.top + childOffset.height / 2 - popoverHeight / 2,
                        left: childOffset.left - popoverWidth - caretSize
                    };
                case 'top':
                    return {
                        top: childOffset.top - popoverHeight - caretSize,
                        left: childOffset.left + childOffset.width / 2 - popoverWidth / 2
                    };
                case 'bottom':
                    return {
                        top: childOffset.top + childOffset.height + caretSize,
                        left: childOffset.left + childOffset.width / 2 - popoverWidth / 2
                    };
                default:
                    throw new Error('calcPopoverPosition(): No such placement of [' + this.props.placement + '] found.');
            }
        }
    }, {
        key: 'getPosition',
        value: function getPosition() {
            var node = _reactDom2['default'].findDOMNode(this);
            var container = this.getContainerDOMNode();

            var offset = container.tagName === 'BODY' ? _utilsDomUtils2['default'].offset(node) : _utilsDomUtils2['default'].position(node, container);

            return (0, _objectAssign2['default'])({}, offset, {
                height: node.offsetHeight,
                width: node.offsetWidth
            });
        }

        // used by Mixin
    }, {
        key: 'renderOverlay',
        value: function renderOverlay() {
            if (!this.state.isPopoverActive) {
                return _react2['default'].createElement('span', null);
            }

            var popover = this.props.popover;

            return cloneElement(this.props.popover, {
                onRequestHide: this.close,
                placement: this.props.placement,
                positionLeft: this.state.popoverLeft,
                positionTop: this.state.popoverTop,
                amStyle: popover.props.amStyle || this.props.amStyle,
                amSize: popover.props.amSize || this.props.amSize
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var child = _react2['default'].Children.only(this.props.children);

            var props = {};

            props.onClick = (0, _utilsCreateChainedFunction2['default'])(child.props.onClick, this.props.onClick);

            if (isOneOf('click', this.props.trigger)) {
                props.onClick = (0, _utilsCreateChainedFunction2['default'])(this.toggle, props.onClick);
            }

            if (isOneOf('hover', this.props.trigger)) {
                props.onMouseOver = (0, _utilsCreateChainedFunction2['default'])(this.handleDelayedOpen, this.props.onMouseOver);
                props.onMouseOut = (0, _utilsCreateChainedFunction2['default'])(this.handleDelayedClose, this.props.onMouseOut);
            }

            if (isOneOf('focus', this.props.trigger)) {
                props.onFocus = (0, _utilsCreateChainedFunction2['default'])(this.handleDelayedOpen, this.props.onFocus);
                props.onBlur = (0, _utilsCreateChainedFunction2['default'])(this.handleDelayedClose, this.props.onBlur);
            }

            return cloneElement(child, props);
        }
    }]);

    return PopoverTrigger;
})(_react2['default'].Component);

PopoverTrigger.displayName = "Popover";

PopoverTrigger.propTypes = {
    trigger: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.oneOf(['click', 'hover', 'focus']), _react2['default'].PropTypes.arrayOf(_react2['default'].PropTypes.oneOf(['click', 'hover', 'focus']))]),
    placement: _react2['default'].PropTypes.oneOf(['top', 'right', 'bottom', 'left']),
    delay: _react2['default'].PropTypes.number,
    delayOpen: _react2['default'].PropTypes.number,
    delayClose: _react2['default'].PropTypes.number,
    defaultPopoverActive: _react2['default'].PropTypes.bool,
    popover: _react2['default'].PropTypes.node.isRequired
};

PopoverTrigger.defaultProps = {
    placement: 'right',
    trigger: ['hover', 'focus']
};

module.exports = PopoverTrigger;