'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var Progress = (function (_React$Component) {
    _inherits(Progress, _React$Component);

    function Progress(props) {
        _classCallCheck(this, Progress);

        _get(Object.getPrototypeOf(Progress.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.renderProgressBar = this.renderProgressBar.bind(this);
        this.renderChildBar = this.renderChildBar.bind(this);
    }

    _createClass(Progress, [{
        key: 'renderProgressBar',
        value: function renderProgressBar() {
            var styleSheet = {
                width: this.props.now + '%'
            };
            var classes = {};
            var prefix = this.prefixClass('bar');
            var amStyle = this.props.amStyle;

            // set am-progress-bar
            classes[prefix] = true;

            if (amStyle) {
                classes[prefix + '-' + amStyle] = true;
            }

            return _react2['default'].createElement(
                'div',
                {
                    className: (0, _classnames2['default'])(classes),
                    style: styleSheet,
                    role: 'progressbar' },
                this.props.label
            );
        }
    }, {
        key: 'renderChildBar',
        value: function renderChildBar(child, index) {
            return _react2['default'].cloneElement(child, {
                isChild: true,
                key: child.key ? child.key : index
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var classes = this.getClassSet();

            // set class
            classes[this.prefixClass('striped')] = this.props.striped;

            if (this.props.active) {
                classes[this.prefixClass('striped')] = true;
            }

            if (!this.props.children) {
                if (!this.props.isChild) {
                    return _react2['default'].createElement(
                        'div',
                        _extends({}, this.props, {
                            className: (0, _classnames2['default'])(classes, this.props.className)
                        }),
                        this.renderProgressBar()
                    );
                } else {
                    return this.renderProgressBar();
                }
            } else {
                return _react2['default'].createElement(
                    'div',
                    _extends({}, this.props, {
                        className: (0, _classnames2['default'])(classes, this.props.className)
                    }),
                    _react2['default'].Children.map(this.props.children, this.renderChildBar)
                );
            }
        }
    }]);

    return Progress;
})(_react2['default'].Component);

Progress.displayName = "Progress";

Progress.propTypes = {
    now: _react2['default'].PropTypes.number,
    label: _react2['default'].PropTypes.string,
    active: _react2['default'].PropTypes.bool,
    striped: _react2['default'].PropTypes.bool,
    amSize: _react2['default'].PropTypes.string,
    amStyle: _react2['default'].PropTypes.string
};

Progress.defaultProps = {
    classPrefix: 'progress'
};

module.exports = Progress;