'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var _utilsIsInViewport = require('./utils/isInViewport');

var _utilsIsInViewport2 = _interopRequireDefault(_utilsIsInViewport);

var _utilsEvents = require('./utils/Events');

var _utilsEvents2 = _interopRequireDefault(_utilsEvents);

var _utilsTransitionEvents = require('./utils/TransitionEvents');

var _utilsTransitionEvents2 = _interopRequireDefault(_utilsTransitionEvents);

var _utilsRequestAnimationFrame = require('./utils/requestAnimationFrame');

var _utilsRequestAnimationFrame2 = _interopRequireDefault(_utilsRequestAnimationFrame);

var _utilsDebounce = require('./utils/debounce');

var _utilsDebounce2 = _interopRequireDefault(_utilsDebounce);

var cloneElement = _react2['default'].cloneElement;

var ScrollSpy = (function (_React$Component) {
    _inherits(ScrollSpy, _React$Component);

    function ScrollSpy(props) {
        _classCallCheck(this, ScrollSpy);

        _get(Object.getPrototypeOf(ScrollSpy.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.state = {
            inViewport: false
        };
        this.componentWillMount = this.componentWillMount.bind(this);
        this.componentWillUnmount = this.componentWillUnmount.bind(this);
        this.checkIsInView = this.checkIsInView.bind(this);
        this.checkRAF = this.checkRAF.bind(this);
    }

    _createClass(ScrollSpy, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.mounted = true;
            this.checkRAF();

            var debounced = (0, _utilsDebounce2['default'])(this.checkRAF, 60).bind(this);

            this._scrollListener = _utilsEvents2['default'].on(window, 'scroll', this.checkRAF);
            this._resizeListener = _utilsEvents2['default'].on(window, 'resize', debounced);
            this._orientationListener = _utilsEvents2['default'].on(window, 'orientationchange', debounced);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.mounted = false;
            this._scrollListener && this._scrollListener.off();
            this._resizeListener && this._resizeListener.off();
            this._orientationListener && this._orientationListener.off();
            clearTimeout(this._timer);
        }
    }, {
        key: 'checkIsInView',
        value: function checkIsInView() {
            if (!_utilsTransitionEvents2['default'].support.animationend) {
                return;
            }

            if (this.mounted) {
                var isInView = (0, _utilsIsInViewport2['default'])(_reactDom2['default'].findDOMNode(this));

                if (isInView && !this.state.inViewport) {
                    if (this._timer) {
                        clearTimeout(this._timer);
                    }

                    this._timer = setTimeout((function () {
                        this.setState({
                            inViewport: true
                        });
                    }).bind(this), this.props.delay);
                }

                if (this.props.repeat && !isInView) {
                    this.setState({
                        inViewport: false
                    });
                }
            }
        }
    }, {
        key: 'checkRAF',
        value: function checkRAF() {
            (0, _utilsRequestAnimationFrame2['default'])(this.checkIsInView);
        }
    }, {
        key: 'render',
        value: function render() {
            var animation = this.state.inViewport ? this.setClassNamespace('animation-' + this.props.animation) : null;
            var child = _react2['default'].Children.only(this.props.children);

            // transfer child's props to cloned element
            return cloneElement(child, (0, _objectAssign2['default'])({}, child.props, {
                className: (0, _classnames2['default'])(child.props.className, animation),
                'data-scrollspy': 'animation', // style helper
                delay: this.props.delay
            }));
        }
    }]);

    return ScrollSpy;
})(_react2['default'].Component);

ScrollSpy.displayName = "ScrollSpy ";

ScrollSpy.propTypes = {
    animation: _react2['default'].PropTypes.string,
    delay: _react2['default'].PropTypes.number,
    repeat: _react2['default'].PropTypes.bool
};

ScrollSpy.defaultProps = {
    animation: 'fade',
    delay: 0,
    repeat: false
};

module.exports = ScrollSpy;