'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsSmoothScrollMixin = require('./mixins/SmoothScrollMixin');

var _mixinsSmoothScrollMixin2 = _interopRequireDefault(_mixinsSmoothScrollMixin);

var _utilsIsInViewport = require('./utils/isInViewport');

var _utilsIsInViewport2 = _interopRequireDefault(_utilsIsInViewport);

var _utilsEvents = require('./utils/Events');

var _utilsEvents2 = _interopRequireDefault(_utilsEvents);

var _utilsRequestAnimationFrame = require('./utils/requestAnimationFrame');

var _utilsRequestAnimationFrame2 = _interopRequireDefault(_utilsRequestAnimationFrame);

var _utilsDebounce = require('./utils/debounce');

var _utilsDebounce2 = _interopRequireDefault(_utilsDebounce);

var _utilsCSSCore = require('./utils/CSSCore');

var _utilsCSSCore2 = _interopRequireDefault(_utilsCSSCore);

var _utilsDomUtils = require('./utils/domUtils');

var _utilsDomUtils2 = _interopRequireDefault(_utilsDomUtils);

var _utilsCreateChainedFunction = require('./utils/createChainedFunction');

var _utilsCreateChainedFunction2 = _interopRequireDefault(_utilsCreateChainedFunction);

var _constantsJsx = require('./constants.js');

var _constantsJsx2 = _interopRequireDefault(_constantsJsx);

var cloneElement = _react2['default'].cloneElement;

var ScrollSpyNav = (function (_React$Component) {
    _inherits(ScrollSpyNav, _React$Component);

    function ScrollSpyNav(props) {
        _classCallCheck(this, ScrollSpyNav);

        _get(Object.getPrototypeOf(ScrollSpyNav.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsSmoothScrollMixin2['default']) {
            this[v] = _mixinsSmoothScrollMixin2['default'][v].bind(this);
        }

        this.componentDidMount = this.componentDidMount.bind(this);
        this.componentWillMount = this.componentWillMount.bind(this);
        this.componentWillUnmount = this.componentWillUnmount.bind(this);
        this._init = this._init.bind(this);
        this.checkIsInView = this.checkIsInView.bind(this);
        this.checkRAF = this.checkRAF.bind(this);
        this.handleClick = this.handleClick.bind(this);
    }

    _createClass(ScrollSpyNav, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.mounted = true;
            this._init();
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.checkRAF();
            var debounced = (0, _utilsDebounce2['default'])(this.checkRAF, 100).bind(this);
            this._scrollListener = _utilsEvents2['default'].on(window, 'scroll', this.checkRAF);
            this._resizeListener = _utilsEvents2['default'].on(window, 'resize', debounced);
            this._orientationListener = _utilsEvents2['default'].on(window, 'orientationchange', debounced);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.mounted = false;
            this._scrollListener && this._scrollListener.off();
            this._resizeListener && this._resizeListener.off();
            this._orientationListener && this._orientationListener.off();
        }
    }, {
        key: '_init',
        value: function _init() {
            this._linkNodes = _reactDom2['default'].findDOMNode(this).querySelectorAll('a[href^="#"]');
            this._anchorNodes = [];

            Array.prototype.forEach.call(this._linkNodes, (function (link) {
                var anchor = document.getElementById(link.getAttribute('href').substr(1));

                if (anchor) {
                    this._anchorNodes.push(anchor);
                }
            }).bind(this));
        }
    }, {
        key: 'checkIsInView',
        value: function checkIsInView() {
            var _this = this;

            if (this.mounted) {
                var _ret = (function () {
                    var inViewsNodes = [];

                    _this._anchorNodes.forEach(function (anchor) {
                        if ((0, _utilsIsInViewport2['default'])(anchor)) {
                            inViewsNodes.push(anchor);
                        }
                    });

                    if (inViewsNodes.length) {
                        var targetNode = undefined;

                        inViewsNodes.every(function (node) {
                            if (_utilsDomUtils2['default'].offset(node).top >= _utilsDomUtils2['default'].scrollTop(window)) {
                                targetNode = node;
                                return false; // break loop
                            }
                            return true;
                        });

                        if (!targetNode) {
                            return {
                                v: undefined
                            };
                        }

                        Array.prototype.forEach.call(_this._linkNodes, (function (link) {
                            _utilsCSSCore2['default'].removeClass(link, this.props.activeClass);
                        }).bind(_this));

                        var targetLink = _reactDom2['default'].findDOMNode(_this).querySelector('a[href="#' + targetNode.id + '"]');

                        targetLink && _utilsCSSCore2['default'].addClass(targetLink, _this.props.activeClass);
                    }
                })();

                if (typeof _ret === 'object') return _ret.v;
            }
        }
    }, {
        key: 'checkRAF',
        value: function checkRAF() {
            (0, _utilsRequestAnimationFrame2['default'])(this.checkIsInView);
        }

        // Smooth scroll
    }, {
        key: 'handleClick',
        value: function handleClick(e) {
            e.preventDefault();

            if (e.target && e.target.nodeName === 'A') {
                var targetNode = document.getElementById(e.target.getAttribute('href').substr(1));

                targetNode && this.smoothScroll(window, {
                    position: _utilsDomUtils2['default'].offset(targetNode).top - this.props.offsetTop || 0
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var child = _react2['default'].Children.only(this.props.children);

            // transfer child's props to cloned element
            return cloneElement(child, (0, _objectAssign2['default'])({}, this.props, child.props, {
                onClick: (0, _utilsCreateChainedFunction2['default'])(this.handleClick, child.props.onClick),
                className: (0, _classnames2['default'])(this.props.className, child.props.className)
            }));
        }
    }]);

    return ScrollSpyNav;
})(_react2['default'].Component);

ScrollSpyNav.displayName = "ScrollSpy ";

ScrollSpyNav.propTypes = {
    activeClass: _react2['default'].PropTypes.string,
    offsetTop: _react2['default'].PropTypes.number
};

ScrollSpyNav.defaultProps = {
    activeClass: _constantsJsx2['default'].CLASSES.active
};

module.exports = ScrollSpyNav;