'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var _dropdownJsx = require('./dropdown.js');

var _dropdownJsx2 = _interopRequireDefault(_dropdownJsx);

var _iconJsx = require('./icon.js');

var _iconJsx2 = _interopRequireDefault(_iconJsx);

var _inputJsx = require('./input.js');

var _inputJsx2 = _interopRequireDefault(_inputJsx);

var Selected = (function (_React$Component) {
    _inherits(Selected, _React$Component);

    function Selected(props) {
        _classCallCheck(this, Selected);

        _get(Object.getPrototypeOf(Selected.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.state = {
            value: props.value,
            dropdownWidth: null,
            filterText: null
        };
        this.componentDidMount = this.componentDidMount.bind(this);
        this.componentWillUnmount = this.componentWillUnmount.bind(this);
        this.setDropdownWidth = this.setDropdownWidth.bind(this);
        this.getValueArray = this.getValueArray.bind(this);
        this.hasValue = this.hasValue.bind(this);
        this.setValue = this.setValue.bind(this);
        this.handleCheck = this.handleCheck.bind(this);
        this.handleUserInput = this.handleUserInput.bind(this);
        this.clearFilterInput = this.clearFilterInput.bind(this);
        this.getValue = this.getValue.bind(this);
    }

    _createClass(Selected, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.mounted = true;
            this.setDropdownWidth();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.mounted = false;
        }
    }, {
        key: 'setDropdownWidth',
        value: function setDropdownWidth() {
            if (this.mounted) {
                var toggleButton = _reactDom2['default'].findDOMNode(this.refs.dropdown.refs.dropdownToggle);

                toggleButton && this.setState({ dropdownWidth: toggleButton.offsetWidth });
            }
        }
    }, {
        key: 'getValueArray',
        value: function getValueArray() {
            return this.state.value ? this.state.value.split(this.props.delimiter) : [];
        }
    }, {
        key: 'hasValue',
        value: function hasValue(value) {
            return this.getValueArray().indexOf(value) > -1;
        }
    }, {
        key: 'setValue',
        value: function setValue(value, callback) {
            this.setState({
                value: value
            }, function () {
                this.props.onChange(value);
                callback && callback();
            });
        }
    }, {
        key: 'handleCheck',
        value: function handleCheck(option, e) {
            e.preventDefault();

            var clickedValue = option.value;

            // multiple select
            if (this.props.multiple) {
                var values = this.getValueArray();

                if (this.hasValue(clickedValue)) {
                    values.splice(values.indexOf(clickedValue), 1);
                } else {
                    values.push(clickedValue);
                }

                this.setValue(values.join(this.props.delimiter));
            } else {
                this.setValue(clickedValue);
                this.refs.dropdown.setDropdownState(false);
            }
        }
    }, {
        key: 'handleUserInput',
        value: function handleUserInput(e) {
            e.preventDefault();

            this.setState({
                filterText: _reactDom2['default'].findDOMNode(this.refs.filterInput).value
            });
        }

        // clear filter
    }, {
        key: 'clearFilterInput',
        value: function clearFilterInput() {
            if (this.props.multiple && this.props.searchBox) {
                this.setState({
                    filterText: null
                });
                _reactDom2['default'].findDOMNode(this.refs.filterInput).value = null;
            }
        }

        // API for getting component value
    }, {
        key: 'getValue',
        value: function getValue() {
            return this.state.value;
        }
    }, {
        key: 'render',
        value: function render() {
            var classSet = this.getClassSet();
            var selectedLabel = [];
            var items = [];
            var filterText = this.state.filterText;
            var groupHeader = undefined;

            this.props.data.forEach((function (option, i) {
                var checked = this.hasValue(option.value);
                var checkedClass = checked ? this.setClassNamespace('checked') : null;
                var checkedIcon = checked ? _react2['default'].createElement(_iconJsx2['default'], { icon: 'check' }) : null;

                checked && selectedLabel.push(option.label);

                // add group header
                if (option.group && groupHeader !== option.group) {
                    groupHeader = option.group;
                    items.push(_react2['default'].createElement(
                        'li',
                        {
                            className: this.prefixClass('list-header'),
                            key: 'header' + i },
                        groupHeader
                    ));
                }

                if (filterText && !this.props.optionFilter(filterText, option)) {
                    return;
                }

                items.push(_react2['default'].createElement(
                    'li',
                    {
                        className: checkedClass,
                        onClick: this.handleCheck.bind(this, option),
                        key: i },
                    _react2['default'].createElement(
                        'span',
                        { className: this.prefixClass('text') },
                        option.label
                    ),
                    checkedIcon
                ));
            }).bind(this));

            var status = _react2['default'].createElement(
                'span',
                {
                    className: (0, _classnames2['default'])(this.prefixClass('status'), this.setClassNamespace('fl')) },
                selectedLabel.length ? selectedLabel.join(', ') : _react2['default'].createElement(
                    'span',
                    { className: this.prefixClass('placeholder ') },
                    this.props.placeholder
                )
            );
            var optionsStyle = {};

            if (this.props.maxHeight) {
                optionsStyle = {
                    maxHeight: this.props.maxHeight,
                    overflowY: 'scroll'
                };
            }

            return _react2['default'].createElement(
                _dropdownJsx2['default'],
                {
                    className: (0, _classnames2['default'])(this.props.className, classSet),
                    title: status,
                    onClose: this.clearFilterInput,
                    btnStyle: this.props.btnStyle,
                    btnInlineStyle: { width: this.props.btnWidth },
                    contentInlineStyle: { minWidth: this.state.dropdownWidth },
                    toggleClassName: this.prefixClass('btn'),
                    caretClassName: this.prefixClass('icon'),
                    contentClassName: this.prefixClass('content'),
                    contentTag: 'div',
                    dropup: this.props.dropup,
                    ref: 'dropdown' },
                this.props.searchBox ? _react2['default'].createElement(
                    'div',
                    { className: this.prefixClass('search') },
                    _react2['default'].createElement(_inputJsx2['default'], {
                        onChange: this.handleUserInput,
                        autoComplete: 'off',
                        standalone: true,
                        ref: 'filterInput' })
                ) : null,
                _react2['default'].createElement(
                    'ul',
                    {
                        style: optionsStyle,
                        className: this.prefixClass('list') },
                    items
                ),
                _react2['default'].createElement('input', {
                    name: this.props.name,
                    type: 'hidden',
                    ref: 'selectedField',
                    value: this.state.value })
            );
        }
    }]);

    return Selected;
})(_react2['default'].Component);

Selected.displayName = "Selected";

Selected.propTypes = {
    classPrefix: _react2['default'].PropTypes.string,
    data: _react2['default'].PropTypes.array.isRequired,
    placeholder: _react2['default'].PropTypes.string,
    value: _react2['default'].PropTypes.string,
    multiple: _react2['default'].PropTypes.bool,
    searchBox: _react2['default'].PropTypes.bool,
    name: _react2['default'].PropTypes.string,
    onChange: _react2['default'].PropTypes.func,
    optionFilter: _react2['default'].PropTypes.func,
    dropup: _react2['default'].PropTypes.bool,
    btnWidth: _react2['default'].PropTypes.number,
    btnStyle: _react2['default'].PropTypes.string,
    maxHeight: _react2['default'].PropTypes.number,
    delimiter: _react2['default'].PropTypes.string
};

Selected.defaultProps = {
    classPrefix: 'selected',
    placeholder: '点击选择...',
    onChange: function onChange() {},
    delimiter: ',',
    optionFilter: function optionFilter(filterText, option) {
        return option.label.toLowerCase().indexOf(filterText) > -1;
    }
};

module.exports = Selected;