'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var Slider = (function (_React$Component) {
    _inherits(Slider, _React$Component);

    function Slider(props) {
        _classCallCheck(this, Slider);

        _get(Object.getPrototypeOf(Slider.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.state = {
            activeIndex: this.props.defaultActiveIndex == null ? 0 : this.props.defaultActiveIndex,
            previousActiveIndex: null,
            direction: null
        };
        this.componentWillReceiveProps = this.componentWillReceiveProps.bind(this);
        this.componentDidMount = this.componentDidMount.bind(this);
        this.componentWillUnmount = this.componentWillUnmount.bind(this);
        this.next = this.next.bind(this);
        this.prev = this.prev.bind(this);
        this.pause = this.pause.bind(this);
        this.play = this.play.bind(this);
        this.waitForNext = this.waitForNext.bind(this);
        this.handleMouseOver = this.handleMouseOver.bind(this);
        this.handleMouseOut = this.handleMouseOut.bind(this);
        this.getActiveIndex = this.getActiveIndex.bind(this);
        this.handleItemAnimateOutEnd = this.handleItemAnimateOutEnd.bind(this);
        this.handleSelect = this.handleSelect.bind(this);
        this.renderDirectionNav = this.renderDirectionNav.bind(this);
        this.renderControlNav = this.renderControlNav.bind(this);
        this.renderItem = this.renderItem.bind(this);
    }

    _createClass(Slider, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            var activeIndex = this.getActiveIndex();

            if (nextProps.activeIndex != null && nextProps.activeIndex !== activeIndex) {
                clearTimeout(this.timeout);
                this.setState({
                    previousActiveIndex: activeIndex,
                    direction: nextProps.direction != null ? nextProps.direction : this.getDirection(activeIndex, nextProps.activeIndex)
                });
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.props.autoPlay && this.waitForNext();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            clearTimeout(this.timeout);
        }
    }, {
        key: 'getDirection',
        value: function getDirection(prevIndex, index) {
            if (prevIndex === index) {
                return null;
            }

            return prevIndex > index ? 'prev' : 'next';
        }
    }, {
        key: 'next',
        value: function next(e) {
            e && e.preventDefault();

            var index = this.getActiveIndex() + 1;
            var count = _react2['default'].Children.count(this.props.children);
            if (index > count - 1) {
                if (!this.props.loop) {
                    return;
                }
                index = 0;
            }

            this.handleSelect(index, 'next');
        }
    }, {
        key: 'prev',
        value: function prev(e) {
            e && e.preventDefault();

            var index = this.getActiveIndex() - 1;

            if (index < 0) {
                if (!this.props.loop) {
                    return;
                }
                index = _react2['default'].Children.count(this.props.children) - 1;
            }

            this.handleSelect(index, 'prev');
        }
    }, {
        key: 'pause',
        value: function pause() {
            this.isPaused = true;
            clearTimeout(this.timeout);
        }
    }, {
        key: 'play',
        value: function play() {
            this.isPaused = false;
            this.waitForNext();
        }
    }, {
        key: 'waitForNext',
        value: function waitForNext() {
            if (!this.isPaused && this.props.slide && this.props.slideSpeed && this.props.activeIndex == null) {
                this.timeout = setTimeout(this.next, this.props.slideSpeed);
            }
        }
    }, {
        key: 'handleMouseOver',
        value: function handleMouseOver() {
            if (this.props.pauseOnHover) {
                this.pause();
            }
        }
    }, {
        key: 'handleMouseOut',
        value: function handleMouseOut() {
            if (this.isPaused) {
                this.play();
            }
        }
    }, {
        key: 'getActiveIndex',
        value: function getActiveIndex() {
            return this.props.activeIndex != null ? this.props.activeIndex : this.state.activeIndex;
        }
    }, {
        key: 'handleItemAnimateOutEnd',
        value: function handleItemAnimateOutEnd() {
            this.setState({
                previousActiveIndex: null,
                direction: null
            }, function () {
                this.waitForNext();

                if (this.props.onSlideEnd) {
                    this.props.onSlideEnd();
                }
            });
        }
    }, {
        key: 'handleSelect',
        value: function handleSelect(index, direction, e) {
            e && e.preventDefault();
            clearTimeout(this.timeout);

            var previousActiveIndex = this.getActiveIndex();
            direction = direction || this.getDirection(previousActiveIndex, index);

            if (this.props.onSelect) {
                this.props.onSelect(index, direction);
            }

            if (this.props.activeIndex == null && index !== previousActiveIndex) {
                //�������ҵ��޸ģ���ʱ�����������Ĺ�������
                /*if (this.state.previousActiveIndex != null) {
                    // If currently animating don't activate the new index.
                    // TODO: look into queuing this canceled call and
                    // animating after the current animation has ended.
                    return;
                }*/
                this.setState({
                    activeIndex: index,
                    previousActiveIndex: previousActiveIndex,
                    direction: direction
                });
            }
        }
    }, {
        key: 'renderDirectionNav',
        value: function renderDirectionNav() {
            return this.props.directionNav ? _react2['default'].createElement(
                'ul',
                { className: this.setClassNamespace('direction-nav') },
                _react2['default'].createElement(
                    'li',
                    null,
                    _react2['default'].createElement(
                        'a',
                        {
                            onTouchTap: this.prev,
                            className: this.setClassNamespace('prev'),
                            href: '#prev' },
                        'Previous'
                    )
                ),
                _react2['default'].createElement(
                    'li',
                    null,
                    _react2['default'].createElement(
                        'a',
                        {
                            onTouchTap: this.next,
                            className: this.setClassNamespace('next'),
                            href: '#next' },
                        'Next'
                    )
                )
            ) : null;
        }
    }, {
        key: 'renderControlNav',
        value: function renderControlNav() {
            var _this = this;

            if (this.props.controlNav) {
                var _ret = (function () {
                    var isThumbnailNav = false;
                    var children = _react2['default'].Children.map(_this.props.children, (function (child, i) {
                        var className = i === this.getActiveIndex() ? this.setClassNamespace('active') : null;

                        if (!isThumbnailNav) {
                            isThumbnailNav = !!child.props.thumbnail;
                        }

                        var thumb = child.props.thumbnail;

                        return _react2['default'].createElement(
                            'li',
                            {
                                onTouchTap: this.handleSelect.bind(this, i, null),
                                key: i },
                            thumb ? _react2['default'].createElement('img', { className: className, src: thumb }) : _react2['default'].createElement('a', { href: '#' + i, className: className }),
                            _react2['default'].createElement('i', null)
                        );
                    }).bind(_this));
                    var controlClass = _this.setClassNamespace('control-' + (isThumbnailNav ? 'thumbs' : 'paging'));

                    return {
                        v: _react2['default'].createElement(
                            'ol',
                            {
                                className: (0, _classnames2['default'])(_this.setClassNamespace('control-nav'), controlClass) },
                            children
                        )
                    };
                })();

                if (typeof _ret === 'object') return _ret.v;
            }

            return null;
        }
    }, {
        key: 'renderItem',
        value: function renderItem(child, index) {
            var activeIndex = this.getActiveIndex();
            var isActive = index === activeIndex;
            var isPreviousActive = this.state.previousActiveIndex != null && this.state.previousActiveIndex === index && this.props.slide;

            return _react2['default'].cloneElement(child, {
                active: isActive,
                ref: child.ref,
                key: child.key ? child.key : index,
                index: index,
                animateOut: isPreviousActive,
                animateIn: isActive && this.state.previousActiveIndex != null && this.props.slide,
                direction: this.state.direction,
                onAnimateOutEnd: isPreviousActive ? this.handleItemAnimateOutEnd : null
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var classSet = this.getClassSet();
            var viewportStyle = {
                overflow: 'hidden',
                position: 'relative',
                width: '100%'
            };

            // React version slider style
            classSet[this.prefixClass('slide')] = true;

            return _react2['default'].createElement(
                'div',
                _extends({}, this.props, {
                    className: (0, _classnames2['default'])(classSet, this.props.className),
                    onMouseOver: this.handleMouseOver,
                    onMouseOut: this.handleMouseOut }),
                _react2['default'].createElement(
                    'div',
                    {
                        className: this.setClassNamespace('viewport'),
                        style: viewportStyle },
                    _react2['default'].createElement(
                        'ul',
                        { className: this.setClassNamespace('slides') },
                        _react2['default'].Children.map(this.props.children, this.renderItem)
                    )
                ),
                this.renderDirectionNav(),
                this.renderControlNav()
            );
        }
    }]);

    return Slider;
})(_react2['default'].Component);

Slider.displayName = "Slider";

Slider.propTypes = {
    theme: _react2['default'].PropTypes.oneOf(['default', 'a1', 'a2', 'a3', 'a4', 'a5', 'b1', 'b2', 'b3', 'b4', 'c1', 'c2', 'c3', 'c4', 'd1', 'd2', 'd3']),
    directionNav: _react2['default'].PropTypes.bool, // prev/next icon
    controlNav: _react2['default'].PropTypes.bool,

    animation: _react2['default'].PropTypes.string, // not working
    slide: _react2['default'].PropTypes.bool,
    autoPlay: _react2['default'].PropTypes.bool,
    slideSpeed: _react2['default'].PropTypes.number, // interval
    loop: _react2['default'].PropTypes.bool, // loop slide

    pauseOnHover: _react2['default'].PropTypes.bool,
    touch: _react2['default'].PropTypes.bool, // TODO: add touch support

    onSelect: _react2['default'].PropTypes.func,
    onSlideEnd: _react2['default'].PropTypes.func,
    activeIndex: _react2['default'].PropTypes.number,
    defaultActiveIndex: _react2['default'].PropTypes.number,
    direction: _react2['default'].PropTypes.oneOf(['prev', 'next'])
};

Slider.defaultProps = {
    classPrefix: 'slider',
    theme: 'default',
    directionNav: true,
    controlNav: true,
    slide: true,
    autoPlay: true,
    loop: true,
    slideSpeed: 5000,
    pauseOnHover: true
};

module.exports = Slider;