'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var _utilsTransitionEvents = require('./utils/TransitionEvents');

var _utilsTransitionEvents2 = _interopRequireDefault(_utilsTransitionEvents);

var SliderItem = (function (_React$Component) {
    _inherits(SliderItem, _React$Component);

    function SliderItem(props) {
        _classCallCheck(this, SliderItem);

        _get(Object.getPrototypeOf(SliderItem.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.state = {
            direction: null
        };
        this.componentDidMount = this.componentDidMount.bind(this);
        this.componentWillUnmount = this.componentWillUnmount.bind(this);
        this.componentWillReceiveProps = this.componentWillReceiveProps.bind(this);
        this.componentDidUpdate = this.componentDidUpdate.bind(this);
        this.handleAnimateOutEnd = this.handleAnimateOutEnd.bind(this);
        this.startAnimation = this.startAnimation.bind(this);
    }

    _createClass(SliderItem, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.mounted = true;
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.mounted = false;
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.props.active !== nextProps.active) {
                this.setState({
                    direction: null
                });
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps) {
            if (!this.props.active && prevProps.active) {
                _utilsTransitionEvents2['default'].on(_reactDom2['default'].findDOMNode(this), this.handleAnimateOutEnd);
            }

            //����״̬�ı��ˣ���ִ�ж���
            if (this.props.active !== prevProps.active) {
                setTimeout(this.startAnimation, 20);
            }
        }
    }, {
        key: 'handleAnimateOutEnd',
        value: function handleAnimateOutEnd() {
            if (this.props.onAnimateOutEnd && this.mounted) {
                this.props.onAnimateOutEnd(this.props.index);
            }
        }
    }, {
        key: 'startAnimation',
        value: function startAnimation() {
            if (!this.mounted) {
                return;
            }

            this.setState({
                direction: this.props.direction === 'prev' ? 'right' : 'left'
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var classSet = {
                active: this.props.active && !this.props.animateIn || this.props.animateOut,
                next: this.props.active && this.props.animateIn && this.props.direction === 'next',
                prev: this.props.active && this.props.animateIn && this.props.direction === 'prev'
            };

            if (this.state.direction && (this.props.animateIn || this.props.animateOut)) {
                classSet[this.state.direction] = true;
            }

            return _react2['default'].createElement(
                'li',
                {
                    className: (0, _classnames2['default'])(this.props.className, classSet) },
                this.props.children
            );
        }
    }]);

    return SliderItem;
})(_react2['default'].Component);

SliderItem.displayName = "SliderItem";

SliderItem.propTypes = {
    direction: _react2['default'].PropTypes.oneOf(['prev', 'next']),
    onAnimateOutEnd: _react2['default'].PropTypes.func,
    active: _react2['default'].PropTypes.bool,
    animateIn: _react2['default'].PropTypes.bool,
    animateOut: _react2['default'].PropTypes.bool,
    caption: _react2['default'].PropTypes.node,
    index: _react2['default'].PropTypes.number,
    thumbnail: _react2['default'].PropTypes.string
};

SliderItem.defaultProps = {
    animation: true
};

module.exports = SliderItem;