'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var _utilsEvents = require('./utils/Events');

var _utilsEvents2 = _interopRequireDefault(_utilsEvents);

var _utilsDebounce = require('./utils/debounce');

var _utilsDebounce2 = _interopRequireDefault(_utilsDebounce);

var _utilsDomUtils = require('./utils/domUtils');

var _utilsDomUtils2 = _interopRequireDefault(_utilsDomUtils);

var Sticky = (function (_React$Component) {
    _inherits(Sticky, _React$Component);

    function Sticky(props) {
        _classCallCheck(this, Sticky);

        _get(Object.getPrototypeOf(Sticky.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.state = {
            sticked: false,
            holderStyle: null,
            initialized: false,
            stickerStyle: null
        };
        this.componentDidMount = this.componentDidMount.bind(this);
        this.componentWillMount = this.componentWillMount.bind(this);
        this._init = this._init.bind(this);
        this.checkPosition = this.checkPosition.bind(this);
        this.checkMedia = this.checkMedia.bind(this);
        this.resetSticker = this.resetSticker.bind(this);
        this.handleClick = this.handleClick.bind(this);
    }

    _createClass(Sticky, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.mounted = true;
            this._init();
            this.checkPosition();
            var ownerWindow = _utilsDomUtils2['default'].ownerWindow(_reactDom2['default'].findDOMNode(this.refs.sticker));

            this._scrollListener = _utilsEvents2['default'].on(ownerWindow, 'scroll', (0, _utilsDebounce2['default'])(this.checkPosition, 10).bind(this));
            this._resizeListener = _utilsEvents2['default'].on(ownerWindow, 'resize', (0, _utilsDebounce2['default'])(this.checkPosition, 50).bind(this));
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.mounted = false;
            this._scrollListener && this._scrollListener.off();
            this._resizeListener && this._resizeListener.off();
        }
    }, {
        key: '_init',
        value: function _init() {
            if (this.state.initialized || !this.mounted || !this.checkMedia()) {
                return;
            }

            var sticker = _reactDom2['default'].findDOMNode(this.refs.sticker);
            var elStyle = getComputedStyle(sticker);
            var outerHeight = parseInt(elStyle.height, 10) + parseInt(elStyle.marginTop, 10) + parseInt(elStyle.marginBottom, 10);
            var style = {
                height: elStyle.position !== 'absolute' ? outerHeight : '',
                float: elStyle.float !== 'none' ? elStyle.float : '',
                margin: elStyle.margin
            };

            this.setState({
                initialized: true,
                holderStyle: style,
                stickerStyle: {
                    margin: 0
                }
            });
        }
    }, {
        key: 'checkPosition',
        value: function checkPosition() {
            if (this.mounted) {
                var scrollTop = _utilsDomUtils2['default'].scrollTop(window);
                var offsetTop = this.props.top;
                var offsetBottom = this.props.bottom;
                var holder = _reactDom2['default'].findDOMNode(this);

                if (typeof offsetBottom === 'function') {
                    offsetBottom = offsetBottom();
                }

                var checkResult = scrollTop > _utilsDomUtils2['default'].offset(holder).top;

                if (checkResult && !this.state.sticked) {
                    this.setState({
                        stickerStyle: {
                            top: offsetTop,
                            left: _utilsDomUtils2['default'].offset(holder).left,
                            width: holder.offsetWidth
                        }
                    });
                }

                if (this.state.sticked && !checkResult) {
                    this.resetSticker();
                }

                this.setState({
                    sticked: checkResult
                });
            }
        }
    }, {
        key: 'checkMedia',
        value: function checkMedia() {
            // TODO: add element visible detector
            /*if (!this.$element.is(':visible')) {
             return false;
             }*/

            var media = this.props.media;

            if (media) {
                switch (typeof media) {
                    case 'number':
                        if (window.innerWidth < media) {
                            return false;
                        }
                        break;

                    case 'string':
                        if (window.matchMedia && !window.matchMedia(media).matches) {
                            return false;
                        }
                        break;
                }
            }

            return true;
        }
    }, {
        key: 'resetSticker',
        value: function resetSticker() {
            this.setState({
                stickerStyle: {
                    position: '',
                    top: '',
                    width: '',
                    left: '',
                    margin: 0
                }
            });
        }

        // Smooth scroll
    }, {
        key: 'handleClick',
        value: function handleClick(e) {
            e.preventDefault();

            if (e.target && e.target.nodeName === 'A') {
                var targetNode = document.getElementById(e.target.getAttribute('href').substr(1));

                targetNode && this.smoothScroll(window, {
                    position: _utilsDomUtils2['default'].offset(targetNode).top - this.props.offsetTop || 0
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var stickyClass = this.getClassSet();
            var child = _react2['default'].Children.only(this.props.children);
            var animation = this.props.animation && this.state.sticked ? this.setClassNamespace('animation-' + this.props.animation) : null;

            // transfer child's props to cloned element
            return _react2['default'].createElement(
                'div',
                _extends({}, this.props, {
                    style: this.state.holderStyle,
                    className: (0, _classnames2['default'])(this.props.className, this.prefixClass('placeholder')) }),
                _react2['default'].cloneElement(child, (0, _objectAssign2['default'])({}, child.props, {
                    style: this.state.stickerStyle,
                    ref: 'sticker',
                    className: (0, _classnames2['default'])(child.props.className, this.state.sticked ? stickyClass : null, animation)
                }))
            );
        }
    }]);

    return Sticky;
})(_react2['default'].Component);

Sticky.displayName = "Sticky";

Sticky.propTypes = {
    classPrefix: _react2['default'].PropTypes.string,
    media: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.number]),
    top: _react2['default'].PropTypes.number,
    animation: _react2['default'].PropTypes.string,
    bottom: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.number, _react2['default'].PropTypes.func])
};

Sticky.defaultProps = {
    classPrefix: 'sticky',
    top: 0
};

module.exports = Sticky;