'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mixinsClassNameMixin = require('./mixins/ClassNameMixin');

var _mixinsClassNameMixin2 = _interopRequireDefault(_mixinsClassNameMixin);

var TimePicker = (function (_React$Component) {
    _inherits(TimePicker, _React$Component);

    function TimePicker(props) {
        _classCallCheck(this, TimePicker);

        _get(Object.getPrototypeOf(TimePicker.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.state = {
            viewDate: this.props.date,
            selectedDate: this.props.date,
            displayed: {
                times: { display: 'block' },
                minutes: { display: 'none' },
                hours: { display: 'none' }
            }
        };

        this.setTime = this.setTime.bind(this);
        this.setSelectedMinute = this.setSelectedMinute.bind(this);
        this.showMinutes = this.showMinutes.bind(this);
        this.showHours = this.showHours.bind(this);
        this.setSelectedHour = this.setSelectedHour.bind(this);
        this.showTimeText = this.showTimeText.bind(this);
        this.renderHours = this.renderHours.bind(this);
        this.renderMinutes = this.renderMinutes.bind(this);
    }

    // Minutes

    _createClass(TimePicker, [{
        key: 'addMinute',
        value: function addMinute() {
            var viewDate = this.state.viewDate;

            viewDate.setMinutes(viewDate.getMinutes() + 1);

            this.setTime(viewDate);
        }
    }, {
        key: 'subtractMinute',
        value: function subtractMinute() {
            var viewDate = this.state.viewDate;

            viewDate.setMinutes(viewDate.getMinutes() - 1);

            this.setTime(viewDate);
        }
    }, {
        key: 'setTime',
        value: function setTime(viewDate) {
            this.setState({
                viewDate: viewDate,
                selectedDate: new Date(viewDate.valueOf())
            }, function () {
                this.props.onSelect(this.state.selectedDate);
            });
        }

        // set Minutes
    }, {
        key: 'setSelectedMinute',
        value: function setSelectedMinute(event) {
            var viewDate = this.state.viewDate;
            var minute = parseInt(event.target.innerHTML.substr(3));

            viewDate.setMinutes(minute);
            this.setTime(viewDate);

            this.setState({
                displayed: {
                    times: { display: 'block' },
                    minutes: { display: 'none' },
                    hours: { display: 'none' }
                }
            });
        }
    }, {
        key: 'showMinutes',
        value: function showMinutes() {
            this.setState({
                displayed: {
                    times: { display: 'none' },
                    minutes: { display: 'block' },
                    hours: { display: 'none' }
                }
            });
        }

        // Hours
    }, {
        key: 'showHours',
        value: function showHours() {
            this.setState({
                displayed: {
                    times: { display: 'none' },
                    minutes: { display: 'none' },
                    hours: { display: 'block' }
                }
            });
        }
    }, {
        key: 'setSelectedHour',
        value: function setSelectedHour(event) {
            var viewDate = this.state.viewDate;
            var hour = parseInt(event.target.innerHTML);

            viewDate.setHours(hour);
            this.setTime(viewDate);

            this.setState({
                displayed: {
                    times: { display: 'block' },
                    minutes: { display: 'none' },
                    hours: { display: 'none' }
                }
            });
        }
    }, {
        key: 'addHour',
        value: function addHour() {
            var viewDate = this.state.viewDate;

            viewDate.setHours(viewDate.getHours() + 1);

            this.setTime(viewDate);
        }
    }, {
        key: 'subtractHour',
        value: function subtractHour() {
            var viewDate = this.state.viewDate;

            viewDate.setHours(viewDate.getHours() - 1);

            this.setTime(viewDate);
        }
    }, {
        key: 'showTimeText',
        value: function showTimeText() {
            var hour = this.state.viewDate.getHours();
            var minute = this.state.viewDate.getMinutes();

            if (minute < 10) {
                minute = '0' + minute;
            }

            if (hour < 10) {
                hour = '0' + hour;
            }

            return {
                hour: hour,
                minute: minute
            };
        }
    }, {
        key: 'renderHours',
        value: function renderHours() {
            var time = this.showTimeText().hour + ':' + this.showTimeText().minute;

            return _react2['default'].createElement(HoursPicker, {
                style: this.state.displayed.hours,
                setSelectedHour: this.setSelectedHour,
                selectedDate: this.state.selectedDate,
                addHour: this.addHour,
                subtractHour: this.subtractHour,
                showTime: time });
        }
    }, {
        key: 'renderMinutes',
        value: function renderMinutes() {
            var time = this.showTimeText().hour + ':' + this.showTimeText().minute;

            return _react2['default'].createElement(MinutesPicker, {
                style: this.state.displayed.minutes,
                setSelectedMinute: this.setSelectedMinute,
                selectedDate: this.state.selectedDate,
                addMinute: this.addMinute,
                subtractMinute: this.subtractMinute,
                showTime: time });
        }
    }, {
        key: 'render',
        value: function render() {
            var time = this.showTimeText();

            var content = _react2['default'].createElement(
                'div',
                { className: this.prefixClass('time-box') },
                _react2['default'].createElement(
                    'strong',
                    { onClick: this.showHours },
                    time.hour
                ),
                _react2['default'].createElement(
                    'em',
                    null,
                    ':'
                ),
                _react2['default'].createElement(
                    'strong',
                    { onClick: this.showMinutes },
                    time.minute
                )
            );

            return _react2['default'].createElement(
                'div',
                { className: this.prefixClass('body') },
                _react2['default'].createElement(SubPicker, {
                    style: this.state.displayed.times,
                    displayName: 'time-wrapper',
                    body: content,
                    add: this.addMinute,
                    subtract: this.subtractMinute,
                    showFunc: this.props.showDate,
                    showText: 'today' }),
                this.renderHours(),
                this.renderMinutes()
            );
        }
    }]);

    return TimePicker;
})(_react2['default'].Component);

TimePicker.displayName = "TimePicker";

TimePicker.propTypes = {
    onSelect: _react2['default'].PropTypes.func.isRequired,
    date: _react2['default'].PropTypes.object,
    format: _react2['default'].PropTypes.string
};

TimePicker.defaultProps = {
    classPrefix: 'datepicker',
    format: 'HH:mm'
};

module.exports = TimePicker;

/*---------------------------------------------------------------------------*/

var HoursPicker = (function (_React$Component2) {
    _inherits(HoursPicker, _React$Component2);

    function HoursPicker(props) {
        _classCallCheck(this, HoursPicker);

        _get(Object.getPrototypeOf(HoursPicker.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.renderHour = this.renderHour.bind(this);
    }

    _createClass(HoursPicker, [{
        key: 'renderHour',
        value: function renderHour() {
            var classes = undefined;
            var hour = this.props.selectedDate.getHours();
            var i = 0;
            var hours = [];

            while (i < 24) {
                classes = {};
                classes[this.prefixClass('hour')] = true;

                if (i === hour) {
                    classes[this.setClassNamespace('active')] = true;
                }

                hours.push(_react2['default'].createElement(
                    'span',
                    {
                        className: (0, _classnames2['default'])(classes),
                        onClick: this.props.setSelectedHour,
                        key: i },
                    i < 10 ? '0' + i + ':00' : i + ':00'
                ));

                i++;
            }

            return hours;
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2['default'].createElement(SubPicker, {
                displayName: 'hours',
                style: this.props.style,
                subtract: this.props.subtractHour,
                add: this.props.addHour,
                showText: this.props.showTime,
                body: this.renderHour() });
        }
    }]);

    return HoursPicker;
})(_react2['default'].Component);

HoursPicker.displayName = "HoursPicker";

HoursPicker.propTypes = {
    setSelectedHour: _react2['default'].PropTypes.func.isRequired,
    selectedDate: _react2['default'].PropTypes.object.isRequired
};

HoursPicker.defaultProps = {
    classPrefix: 'datepicker'
};

/*---------------------------------------------------------------------------*/

var MinutesPicker = (function (_React$Component3) {
    _inherits(MinutesPicker, _React$Component3);

    function MinutesPicker(props) {
        _classCallCheck(this, MinutesPicker);

        _get(Object.getPrototypeOf(MinutesPicker.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
        this.renderMinute = this.renderMinute.bind(this);
    }

    _createClass(MinutesPicker, [{
        key: 'renderMinute',
        value: function renderMinute() {
            var classes = undefined;
            var minute = this.props.selectedDate.getMinutes();
            var hour = this.props.selectedDate.getHours();
            var i = 0;
            var minutes = [];

            while (i < 60) {
                classes = {};
                classes[this.prefixClass('minute')] = true;

                if (i === minute) {
                    classes[this.setClassNamespace('active')] = true;
                }

                if (i % 5 === 0) {
                    minutes.push(_react2['default'].createElement(
                        'span',
                        {
                            className: (0, _classnames2['default'])(classes),
                            onClick: this.props.setSelectedMinute,
                            key: i
                        },
                        i < 10 ? hour + ':0' + i : hour + ':' + i
                    ));
                }

                i++;
            }

            return minutes;
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2['default'].createElement(SubPicker, {
                displayName: 'minutes',
                style: this.props.style,
                subtract: this.props.subtractMinute,
                add: this.props.addMinute,
                showText: this.props.showTime,
                body: this.renderMinute() });
        }
    }]);

    return MinutesPicker;
})(_react2['default'].Component);

MinutesPicker.displayName = "MinutesPicker";

MinutesPicker.propTypes = {
    setSelectedMinute: _react2['default'].PropTypes.func.isRequired,
    selectedDate: _react2['default'].PropTypes.object.isRequired
};

MinutesPicker.defaultProps = {
    classPrefix: 'datepicker'
};

/*---------------------------------------------------------------------------*/

var SubPicker = (function (_React$Component4) {
    _inherits(SubPicker, _React$Component4);

    function SubPicker(props) {
        _classCallCheck(this, SubPicker);

        _get(Object.getPrototypeOf(SubPicker.prototype), 'constructor', this).call(this, props);
        for (var v in _mixinsClassNameMixin2['default']) {
            this[v] = _mixinsClassNameMixin2['default'][v].bind(this);
        }
    }

    _createClass(SubPicker, [{
        key: 'render',
        value: function render() {
            var prefixClass = this.prefixClass;

            return _react2['default'].createElement(
                'div',
                {
                    className: prefixClass(this.props.displayName),
                    style: this.props.style },
                _react2['default'].createElement(
                    'table',
                    { className: prefixClass('table') },
                    _react2['default'].createElement(
                        'thead',
                        null,
                        _react2['default'].createElement(
                            'tr',
                            { className: prefixClass('header') },
                            _react2['default'].createElement(
                                'th',
                                { className: prefixClass('prev'), onClick: this.props.subtract },
                                _react2['default'].createElement('i', { className: prefixClass('prev-icon') })
                            ),
                            _react2['default'].createElement(
                                'th',
                                {
                                    className: prefixClass('switch'),
                                    colSpan: '5',
                                    onClick: this.props.showFunc
                                },
                                _react2['default'].createElement(
                                    'div',
                                    { className: this.prefixClass('select') },
                                    this.props.showText
                                )
                            ),
                            _react2['default'].createElement(
                                'th',
                                { className: prefixClass('next'), onClick: this.props.add },
                                _react2['default'].createElement('i', { className: prefixClass('next-icon') })
                            )
                        )
                    ),
                    _react2['default'].createElement(
                        'tbody',
                        null,
                        _react2['default'].createElement(
                            'tr',
                            null,
                            _react2['default'].createElement(
                                'td',
                                { colSpan: '7' },
                                this.props.body
                            )
                        )
                    )
                )
            );
        }
    }]);

    return SubPicker;
})(_react2['default'].Component);

SubPicker.displayName = "SubPicker";

SubPicker.defaultProps = {
    classPrefix: 'datepicker'
};